#include <fstream>
#include <time.h>
#include "bmpdecod.h"

using namespace std;

UBYTE1 divisionKub=1;

double log2(double x)

 {return log(x)*1.4426950409;

 }


int countBit(UBYTE4 diapazon)

 {if (diapazon<=1)

   return 0;

  if (diapazon==2)

   return 1;

  if (diapazon<=4)

   return 2;

  if (diapazon<=8)

   return 3;

  if (diapazon<=16)

   return 4;

  if (diapazon<=32)

   return 5;

  if (diapazon<=64)

   return 6;

  if (diapazon<=128)

   return 7;

  if (diapazon<=256)

   return 8;

  if (diapazon<=512)

   return 9;

  if (diapazon<=1024)

   return 10;

  if (diapazon<=2048)

   return 11;

  if (diapazon<=4096)

   return 12;

  if (diapazon<=8192)

   return 13;

  if (diapazon<=16384)

   return 14;

  if (diapazon<=32768)

   return 15;

  if (diapazon<=65536)

   return 16;

  if (diapazon<=131072)

   return 17;

  if (diapazon<=262144)

   return 18;

  if (diapazon<=524288)

   return 19;

  if (diapazon<=1048576)

   return 20;

  if (diapazon<=2097152)

   return 21;

  if (diapazon<=4194304)

   return 22;

  if (diapazon<=8388608)

   return 23;

  if (diapazon<=16777216)

   return 24;

  if (diapazon<=33554432)

   return 25;

  if (diapazon<=67108864)

   return 26;

  return 27;

 }


// 

UBYTE2 countColorPaletr;

UBYTE1 minRColorPaletr[256], maxRColorPaletr[256], minGColorPaletr[256], maxGColorPaletr[256], minBColorPaletr[256], maxBColorPaletr[256];

UBYTE1 countBitRColorPaletr[256], countBitGColorPaletr[256], countBitBColorPaletr[256];

//  

UBYTE1 *bufPlus, countBitPlus;

UBYTE4 rozmBufPlus, pointBufPlus;


UBYTE4 plusBitPodilColorPaletr(UBYTE1 minR, UBYTE1 maxR, UBYTE1 minG, UBYTE1 maxG, UBYTE1 minB, UBYTE1 maxB,

                               UBYTE1 &plusMinR, UBYTE1 &plusMaxR, UBYTE1 &plusMinG, UBYTE1 &plusMaxG, UBYTE1 &plusMinB, UBYTE1 &plusMaxB,
                               UBYTE4 countPointColorPaletr, UBYTE4 firstPoint, UBYTE4 *nextPoint, UBYTE1 *imageData)
 {if (countPointColorPaletr<=40)
   return 0;
  if (maxR-minR==0 &&
      maxG-minG==0 &&
      maxB-minB==0)
   return 0;
  UBYTE4 countR[256], countG[256], countB[256], index, index1, plusBit=0;
  long p, plus;
  //       (   )
  memset(countR, 0, 256*sizeof(UBYTE4));
  memset(countG, 0, 256*sizeof(UBYTE4));
  memset(countB, 0, 256*sizeof(UBYTE4));
  p=firstPoint;
  for (index=0; index<countPointColorPaletr; index++)
   {countR[imageData[3*p]-minR]++;
    countG[imageData[3*p+1]-minG]++;
    countB[imageData[3*p+2]-minB]++;
    p=nextPoint[p];
   }
  plusMinR=minR;
  plusMaxR=maxR;
  plusMinG=minG;
  plusMaxG=maxG;
  plusMinB=minB;
  plusMaxB=maxB;
  UBYTE4 countLeft, countRight; //     
  UBYTE1 tupMega=0, mega;
  if (maxR>minR)
   {countLeft=0;
    countRight=countPointColorPaletr;
    p=countPointColorPaletr*(countBit(maxR-minR+1)-log2(countPointColorPaletr));
    for (index=0; index<maxR-minR; index++) //    
     {if (countR[index]>0)
       {countLeft+=countR[index];
        countRight-=countR[index];
        index1=index+1;
        while (countR[index1]==0)
         index1++; //    
        plus=p-(countLeft*(countBit(index+1)-log2(countLeft))+countRight*(countBit(maxR-minR-index1+1)-log2(countRight)));
        if (plus>0)
         if (plusBit<plus)
          {plusBit=plus;
           tupMega=1;
           mega=minR+index;
          }
       }
     }
   }
  if (maxG>minG)
   {countLeft=0;
    countRight=countPointColorPaletr;
    p=countPointColorPaletr*(countBit(maxG-minG+1)-log2(countPointColorPaletr));
    for (index=0; index<maxG-minG; index++) //    
     {if (countG[index]>0)
       {countLeft+=countG[index];
        countRight-=countG[index];
        index1=index+1;
        while (countG[index1]==0)
         index1++; //    
        plus=p-(countLeft*(countBit(index+1)-log2(countLeft))+countRight*(countBit(maxG-minG-index1+1)-log2(countRight)));
        if (plus>0)
         if (plusBit<plus)
          {plusBit=plus;
           tupMega=2;
           mega=minG+index;
          }
       }
     }
   }
  if (maxB>minB)
   {countLeft=0;
    countRight=countPointColorPaletr;
    p=countPointColorPaletr*(countBit(maxB-minB+1)-log2(countPointColorPaletr));
    for (index=0; index<maxB-minB; index++) //    
     {if (countB[index]>0)
       {countLeft+=countB[index];
        countRight-=countB[index];
        index1=index+1;
        while (countB[index1]==0)
         index1++; //    
        plus=p-(countLeft*(countBit(index+1)-log2(countLeft))+countRight*(countBit(maxB-minB-index1+1)-log2(countRight)));
        if (plus>0)
         if (plusBit<plus)
          {plusBit=plus;
           tupMega=3;
           mega=minB+index;
          }
       }
     }
   }
  switch(tupMega)
   {case 1:plusMaxR=mega;
           break;
    case 2:plusMaxG=mega;
           break;
    case 3:plusMaxB=mega;
           break;
   }
  return plusBit;
 }


void generatePaletr(UBYTE1 *imageData, UBYTE4 *nextPoint, UBYTE1 *indexPointPaletr)

 {UBYTE2 i,j,k,indexMaxPlus, indexColor;

  UBYTE4 firstPointColorPaletr[256], countPointColorPaletr[256];

  UBYTE4 firstPointKub[4][4][4], lastPointKub[4][4][4], countPointKub[4][4][4]; //   ,     64*64*64

  UBYTE1 minR[4][4][4], maxR[4][4][4], minG[4][4][4], maxG[4][4][4], minB[4][4][4], maxB[4][4][4];
  UBYTE4 lastPointColorPaletr[256], plusBitPodil[256];
  UBYTE4 maxCountPointColorPaletr, index, p, maxPlus, countPointPodil;
  UBYTE1 podilMinRColorPaletr[256], podilMaxRColorPaletr[256], podilMinGColorPaletr[256], podilMaxGColorPaletr[256], podilMinBColorPaletr[256], podilMaxBColorPaletr[256];

  for (i=0; i<4; i++)
   for (j=0; j<4; j++)
    for (k=0; k<4; k++)
     countPointKub[i][j][k]=0;
  //   
  p=0;
  do
   {i=imageData[3*p]>>6;
    j=imageData[3*p+1]>>6;
    k=imageData[3*p+2]>>6;
    if (countPointKub[i][j][k]==0) //   
     {firstPointKub[i][j][k]=p;
      minR[i][j][k]=maxR[i][j][k]=imageData[3*p];
      minG[i][j][k]=maxG[i][j][k]=imageData[3*p+1];
      minB[i][j][k]=maxB[i][j][k]=imageData[3*p+2];
     }
    else
     {nextPoint[lastPointKub[i][j][k]]=p;
      if (minR[i][j][k]>imageData[3*p])
       minR[i][j][k]=imageData[3*p];
      if (maxR[i][j][k]<imageData[3*p])
       maxR[i][j][k]=imageData[3*p];
      if (minG[i][j][k]>imageData[3*p+1])
       minG[i][j][k]=imageData[3*p+1];
      if (maxG[i][j][k]<imageData[3*p+1])
       maxG[i][j][k]=imageData[3*p+1];
      if (minB[i][j][k]>imageData[3*p+2])
       minB[i][j][k]=imageData[3*p+2];
      if (maxB[i][j][k]<imageData[3*p+2])
       maxB[i][j][k]=imageData[3*p+2];
     }
    lastPointKub[i][j][k]=p;
    countPointKub[i][j][k]++;
    p=nextPoint[p];
   } while (p!=0);
  //     R
  unsigned int i1,j1,k1;
  for (i=1; i<4; i++)
   for (j=0; j<4; j++)
    for (k=0; k<4; k++)
     {i1=i-1; j1=j; k1=k;
      if ((countPointKub[i][j][k]>0) &&
          (countPointKub[i1][j1][k1]>0)) //   
       if (max(maxR[i][j][k],maxR[i1][j1][k1])-min(minR[i][j][k],minR[i1][j1][k1])<64 &&
           max(maxG[i][j][k],maxG[i1][j1][k1])-min(minG[i][j][k],minG[i1][j1][k1])<64 &&
           max(maxB[i][j][k],maxB[i1][j1][k1])-min(minB[i][j][k],minB[i1][j1][k1])<64)
        {// 
         countPointKub[i][j][k]+=countPointKub[i1][j1][k1];
         countPointKub[i1][j1][k1]=0;
         nextPoint[lastPointKub[i][j][k]]=firstPointKub[i1][j1][k1];
         lastPointKub[i][j][k]=lastPointKub[i1][j1][k1];
         maxR[i][j][k]=max(maxR[i][j][k],maxR[i1][j1][k1]);
         minR[i][j][k]=min(minR[i][j][k],minR[i1][j1][k1]);
         maxG[i][j][k]=max(maxG[i][j][k],maxG[i1][j1][k1]);
         minG[i][j][k]=min(minG[i][j][k],minG[i1][j1][k1]);
         maxB[i][j][k]=max(maxB[i][j][k],maxB[i1][j1][k1]);
         minB[i][j][k]=min(minB[i][j][k],minB[i1][j1][k1]);
        }
     }
  //     G
  for (i=0; i<4; i++)
   for (j=1; j<4; j++)
    for (k=0; k<4; k++)
     {i1=i; j1=j-1; k1=k;
      if ((countPointKub[i][j][k]>0) &&
          (countPointKub[i1][j1][k1]>0)) //   
       if (max(maxR[i][j][k],maxR[i1][j1][k1])-min(minR[i][j][k],minR[i1][j1][k1])<64 &&
           max(maxG[i][j][k],maxG[i1][j1][k1])-min(minG[i][j][k],minG[i1][j1][k1])<64 &&
           max(maxB[i][j][k],maxB[i1][j1][k1])-min(minB[i][j][k],minB[i1][j1][k1])<64)
        {// 
         countPointKub[i][j][k]+=countPointKub[i1][j1][k1];
         countPointKub[i1][j1][k1]=0;
         nextPoint[lastPointKub[i][j][k]]=firstPointKub[i1][j1][k1];
         lastPointKub[i][j][k]=lastPointKub[i1][j1][k1];
         maxR[i][j][k]=max(maxR[i][j][k],maxR[i1][j1][k1]);
         minR[i][j][k]=min(minR[i][j][k],minR[i1][j1][k1]);
         maxG[i][j][k]=max(maxG[i][j][k],maxG[i1][j1][k1]);
         minG[i][j][k]=min(minG[i][j][k],minG[i1][j1][k1]);
         maxB[i][j][k]=max(maxB[i][j][k],maxB[i1][j1][k1]);
         minB[i][j][k]=min(minB[i][j][k],minB[i1][j1][k1]);
        }
     }
  //     B
  for (i=0; i<4; i++)
   for (j=0; j<4; j++)
    for (k=1; k<4; k++)
     {i1=i; j1=j; k1=k-1;
      if ((countPointKub[i][j][k]>0) &&
          (countPointKub[i1][j1][k1]>0)) //   
       if (max(maxR[i][j][k],maxR[i1][j1][k1])-min(minR[i][j][k],minR[i1][j1][k1])<64 &&
           max(maxG[i][j][k],maxG[i1][j1][k1])-min(minG[i][j][k],minG[i1][j1][k1])<64 &&
           max(maxB[i][j][k],maxB[i1][j1][k1])-min(minB[i][j][k],minB[i1][j1][k1])<64)
        {// 
         countPointKub[i][j][k]+=countPointKub[i1][j1][k1];
         countPointKub[i1][j1][k1]=0;
         nextPoint[lastPointKub[i][j][k]]=firstPointKub[i1][j1][k1];
         lastPointKub[i][j][k]=lastPointKub[i1][j1][k1];
         maxR[i][j][k]=max(maxR[i][j][k],maxR[i1][j1][k1]);
         minR[i][j][k]=min(minR[i][j][k],minR[i1][j1][k1]);
         maxG[i][j][k]=max(maxG[i][j][k],maxG[i1][j1][k1]);
         minG[i][j][k]=min(minG[i][j][k],minG[i1][j1][k1]);
         maxB[i][j][k]=max(maxB[i][j][k],maxB[i1][j1][k1]);
         minB[i][j][k]=min(minB[i][j][k],minB[i1][j1][k1]);
        }
     }
  //   
  countColorPaletr=0;
  for (i=0; i<4; i++)
   for (j=0; j<4; j++)
    for (k=0; k<4; k++)
     if (countPointKub[i][j][k]>0)
      {countPointColorPaletr[countColorPaletr]=countPointKub[i][j][k];
       firstPointColorPaletr[countColorPaletr]=firstPointKub[i][j][k];
       lastPointColorPaletr[countColorPaletr]=lastPointKub[i][j][k];
       minRColorPaletr[countColorPaletr]=minR[i][j][k];
       maxRColorPaletr[countColorPaletr]=maxR[i][j][k];
       minGColorPaletr[countColorPaletr]=minG[i][j][k];
       maxGColorPaletr[countColorPaletr]=maxG[i][j][k];
       minBColorPaletr[countColorPaletr]=minB[i][j][k];
       maxBColorPaletr[countColorPaletr]=maxB[i][j][k];
       plusBitPodil[countColorPaletr]=
        plusBitPodilColorPaletr(minRColorPaletr[countColorPaletr], maxRColorPaletr[countColorPaletr],
                                minGColorPaletr[countColorPaletr], maxGColorPaletr[countColorPaletr],
                                minBColorPaletr[countColorPaletr], maxBColorPaletr[countColorPaletr],
                                podilMinRColorPaletr[countColorPaletr], podilMaxRColorPaletr[countColorPaletr],
                                podilMinGColorPaletr[countColorPaletr], podilMaxGColorPaletr[countColorPaletr],
                                podilMinBColorPaletr[countColorPaletr], podilMaxBColorPaletr[countColorPaletr],
                                countPointColorPaletr[countColorPaletr], firstPointColorPaletr[countColorPaletr], nextPoint, imageData);
       countColorPaletr++;
      }
  if (divisionKub)
   {//      
    while (countColorPaletr<256)
     {//     
      indexMaxPlus=0;
      maxPlus=plusBitPodil[0];
      for (i=1; i<countColorPaletr; i++)
       if (plusBitPodil[i]>maxPlus)
        {indexMaxPlus=i;
         maxPlus=plusBitPodil[i];
        }
      if (maxPlus<=40)
       break;
      countPointPodil=countPointColorPaletr[indexMaxPlus];
      p=firstPointColorPaletr[indexMaxPlus];
      countPointColorPaletr[indexMaxPlus]=0;
      countPointColorPaletr[countColorPaletr]=0;
      //    
      for (index=0; index<countPointPodil; index++)
       {if (imageData[3*p]>=podilMinRColorPaletr[indexMaxPlus] &&
            imageData[3*p]<=podilMaxRColorPaletr[indexMaxPlus] &&
            imageData[3*p+1]>=podilMinGColorPaletr[indexMaxPlus] &&
            imageData[3*p+1]<=podilMaxGColorPaletr[indexMaxPlus] &&
            imageData[3*p+2]>=podilMinBColorPaletr[indexMaxPlus] &&
            imageData[3*p+2]<=podilMaxBColorPaletr[indexMaxPlus])
         indexColor=indexMaxPlus;
        else
         indexColor=countColorPaletr;
        if (countPointColorPaletr[indexColor]==0) //    
         {firstPointColorPaletr[indexColor]=p;
          minRColorPaletr[indexColor]=maxRColorPaletr[indexColor]=imageData[3*p];
          minGColorPaletr[indexColor]=maxGColorPaletr[indexColor]=imageData[3*p+1];

          minBColorPaletr[indexColor]=maxBColorPaletr[indexColor]=imageData[3*p+2];

         }

        else
         {nextPoint[lastPointColorPaletr[indexColor]]=p;
          if (minRColorPaletr[indexColor]>imageData[3*p])
           minRColorPaletr[indexColor]=imageData[3*p];
          if (maxRColorPaletr[indexColor]<imageData[3*p])
           maxRColorPaletr[indexColor]=imageData[3*p];
          if (minGColorPaletr[indexColor]>imageData[3*p+1])
           minGColorPaletr[indexColor]=imageData[3*p+1];
          if (maxGColorPaletr[indexColor]<imageData[3*p+1])
           maxGColorPaletr[indexColor]=imageData[3*p+1];
          if (minBColorPaletr[indexColor]>imageData[3*p+2])
           minBColorPaletr[indexColor]=imageData[3*p+2];
          if (maxBColorPaletr[indexColor]<imageData[3*p+2])
           maxBColorPaletr[indexColor]=imageData[3*p+2];
         }
        lastPointColorPaletr[indexColor]=p;
        countPointColorPaletr[indexColor]++;
        p=nextPoint[p];
       }
      plusBitPodil[indexMaxPlus]=
       plusBitPodilColorPaletr(minRColorPaletr[indexMaxPlus], maxRColorPaletr[indexMaxPlus],
                               minGColorPaletr[indexMaxPlus], maxGColorPaletr[indexMaxPlus],
                               minBColorPaletr[indexMaxPlus], maxBColorPaletr[indexMaxPlus],
                               podilMinRColorPaletr[indexMaxPlus], podilMaxRColorPaletr[indexMaxPlus],
                               podilMinGColorPaletr[indexMaxPlus], podilMaxGColorPaletr[indexMaxPlus],
                               podilMinBColorPaletr[indexMaxPlus], podilMaxBColorPaletr[indexMaxPlus],
                               countPointColorPaletr[indexMaxPlus], firstPointColorPaletr[indexMaxPlus], nextPoint, imageData);
      plusBitPodil[countColorPaletr]=
       plusBitPodilColorPaletr(minRColorPaletr[countColorPaletr], maxRColorPaletr[countColorPaletr],
                               minGColorPaletr[countColorPaletr], maxGColorPaletr[countColorPaletr],
                               minBColorPaletr[countColorPaletr], maxBColorPaletr[countColorPaletr],
                               podilMinRColorPaletr[countColorPaletr], podilMaxRColorPaletr[countColorPaletr],
                               podilMinGColorPaletr[countColorPaletr], podilMaxGColorPaletr[countColorPaletr],
                               podilMinBColorPaletr[countColorPaletr], podilMaxBColorPaletr[countColorPaletr],
                               countPointColorPaletr[countColorPaletr], firstPointColorPaletr[countColorPaletr], nextPoint, imageData);
      countColorPaletr++;
      if (countColorPaletr==256) //     
       {long minusUnion, minMinusUnion=maxPlus;
        UBYTE2 indexUnion1=indexMaxPlus;
        UBYTE2 indexUnion2=countColorPaletr-1;
        for (i=0; i<255; i++)
         for (j=i+1; j<=255; j++)
          {minusUnion=(countPointColorPaletr[i]+countPointColorPaletr[j])*
                       (countBit(max(maxRColorPaletr[i],maxRColorPaletr[j])-min(minRColorPaletr[i],minRColorPaletr[j])+1)+
                        countBit(max(maxGColorPaletr[i],maxGColorPaletr[j])-min(minGColorPaletr[i],minGColorPaletr[j])+1)+
                        countBit(max(maxBColorPaletr[i],maxBColorPaletr[j])-min(minBColorPaletr[i],minBColorPaletr[j])+1)-
                        log2(countPointColorPaletr[i]+countPointColorPaletr[j]))-
                      countPointColorPaletr[i]*
                       (countBit(maxRColorPaletr[i]-minRColorPaletr[i]+1)+
                        countBit(maxGColorPaletr[i]-minGColorPaletr[i]+1)+
                        countBit(maxBColorPaletr[i]-minBColorPaletr[i]+1)-
                        log2(countPointColorPaletr[i]))-
                      countPointColorPaletr[j]*
                       (countBit(maxRColorPaletr[j]-minRColorPaletr[j]+1)+
                        countBit(maxGColorPaletr[j]-minGColorPaletr[j]+1)+
                        countBit(maxBColorPaletr[j]-minBColorPaletr[j]+1)-
                        log2(countPointColorPaletr[j]));
           if (minusUnion<minMinusUnion &&
               max(maxRColorPaletr[i],maxRColorPaletr[j])-min(minRColorPaletr[i],minRColorPaletr[j])<128 && //   -  2^7 
               max(maxGColorPaletr[i],maxGColorPaletr[j])-min(minGColorPaletr[i],minGColorPaletr[j])<128 &&
               max(maxBColorPaletr[i],maxBColorPaletr[j])-min(minBColorPaletr[i],minBColorPaletr[j])<128)
            {minMinusUnion=minusUnion;
             indexUnion1=i;
             indexUnion2=j;
            }
          }
        if (minMinusUnion<(long)maxPlus-80) //  
         {minRColorPaletr[indexUnion1]=min(minRColorPaletr[indexUnion1],minRColorPaletr[indexUnion2]);
          minGColorPaletr[indexUnion1]=min(minGColorPaletr[indexUnion1],minGColorPaletr[indexUnion2]);
          minBColorPaletr[indexUnion1]=min(minBColorPaletr[indexUnion1],minBColorPaletr[indexUnion2]);
          maxRColorPaletr[indexUnion1]=max(maxRColorPaletr[indexUnion1],maxRColorPaletr[indexUnion2]);
          maxGColorPaletr[indexUnion1]=max(maxGColorPaletr[indexUnion1],maxGColorPaletr[indexUnion2]);
          maxBColorPaletr[indexUnion1]=max(maxBColorPaletr[indexUnion1],maxBColorPaletr[indexUnion2]);
          countPointColorPaletr[indexUnion1]+=countPointColorPaletr[indexUnion2];
          nextPoint[lastPointColorPaletr[indexUnion1]]=firstPointColorPaletr[indexUnion2];
          lastPointColorPaletr[indexUnion1]=lastPointColorPaletr[indexUnion2];
          plusBitPodil[indexUnion1]=
           plusBitPodilColorPaletr(minRColorPaletr[indexUnion1], maxRColorPaletr[indexUnion1],
                               minGColorPaletr[indexUnion1], maxGColorPaletr[indexUnion1],
                               minBColorPaletr[indexUnion1], maxBColorPaletr[indexUnion1],
                               podilMinRColorPaletr[indexUnion1], podilMaxRColorPaletr[indexUnion1],
                               podilMinGColorPaletr[indexUnion1], podilMaxGColorPaletr[indexUnion1],
                               podilMinBColorPaletr[indexUnion1], podilMaxBColorPaletr[indexUnion1],
                               countPointColorPaletr[indexUnion1], firstPointColorPaletr[indexUnion1], nextPoint, imageData);
          if (indexUnion2!=255)
           {minRColorPaletr[indexUnion2]=minRColorPaletr[255];
            minGColorPaletr[indexUnion2]=minGColorPaletr[255];
            minBColorPaletr[indexUnion2]=minBColorPaletr[255];
            maxRColorPaletr[indexUnion2]=maxRColorPaletr[255];
            maxGColorPaletr[indexUnion2]=maxGColorPaletr[255];
            maxBColorPaletr[indexUnion2]=maxBColorPaletr[255];
            podilMinRColorPaletr[indexUnion2]=podilMinRColorPaletr[255];
            podilMaxRColorPaletr[indexUnion2]=podilMaxRColorPaletr[255];
            podilMinGColorPaletr[indexUnion2]=podilMinGColorPaletr[255];
            podilMaxGColorPaletr[indexUnion2]=podilMaxGColorPaletr[255];
            podilMinBColorPaletr[indexUnion2]=podilMinBColorPaletr[255];
            podilMaxBColorPaletr[indexUnion2]=podilMaxBColorPaletr[255];
            countPointColorPaletr[indexUnion2]=countPointColorPaletr[255];
            firstPointColorPaletr[indexUnion2]=firstPointColorPaletr[255];
            lastPointColorPaletr[indexUnion2]=lastPointColorPaletr[255];
            plusBitPodil[indexUnion2]=plusBitPodil[255];
           }
          countColorPaletr--;
         }
       }
     }
   }
  //     
  UBYTE4 y;

  UBYTE4 prom;

  for (i=1; i<countColorPaletr; i++)

   {y=countPointColorPaletr[i];

    //   

    j=0;

    while (j<i && countPointColorPaletr[j]>=y)

     j++;

    if (j<i) // 

     for (k=i; k>j; k--) //  k  -1

      {//    ,   

       prom=firstPointColorPaletr[k];

       firstPointColorPaletr[k]=firstPointColorPaletr[k-1];

       firstPointColorPaletr[k-1]=prom;

       prom=countPointColorPaletr[k];

       countPointColorPaletr[k]=countPointColorPaletr[k-1];

       countPointColorPaletr[k-1]=prom;

       prom=minRColorPaletr[k];

       minRColorPaletr[k]=minRColorPaletr[k-1];

       minRColorPaletr[k-1]=prom;

       prom=maxRColorPaletr[k];

       maxRColorPaletr[k]=maxRColorPaletr[k-1];

       maxRColorPaletr[k-1]=prom;

       prom=minGColorPaletr[k];

       minGColorPaletr[k]=minGColorPaletr[k-1];

       minGColorPaletr[k-1]=prom;

       prom=maxGColorPaletr[k];

       maxGColorPaletr[k]=maxGColorPaletr[k-1];

       maxGColorPaletr[k-1]=prom;

       prom=minBColorPaletr[k];

       minBColorPaletr[k]=minBColorPaletr[k-1];

       minBColorPaletr[k-1]=prom;

       prom=maxBColorPaletr[k];

       maxBColorPaletr[k]=maxBColorPaletr[k-1];

       maxBColorPaletr[k-1]=prom;

      }

   }

  //        

  rozmBufPlus=0;

  for (i = 0 ; i < countColorPaletr; i++)

   {p=firstPointColorPaletr[i];
    for (index=0; index<countPointColorPaletr[i]; index++) //      
     {indexPointPaletr[p]=i;
      p=nextPoint[p];
     }
    countBitRColorPaletr[i]=countBit(maxRColorPaletr[i]-minRColorPaletr[i]+1);
    countBitGColorPaletr[i]=countBit(maxGColorPaletr[i]-minGColorPaletr[i]+1);
    countBitBColorPaletr[i]=countBit(maxBColorPaletr[i]-minBColorPaletr[i]+1);
    rozmBufPlus+=countPointColorPaletr[i]*(countBitRColorPaletr[i]+countBitGColorPaletr[i]+countBitBColorPaletr[i]);
   }
 }



void writeBufPlus(UBYTE1 w, UBYTE1 countBitW)

 {if (countBitW==0)

   return;

  if (countBitW<8-countBitPlus)

   {bufPlus[pointBufPlus]|=w<<(8-countBitW-countBitPlus);

    countBitPlus+=countBitW;

   }

  else

   {bufPlus[pointBufPlus]|=w>>(countBitW-(8-countBitPlus));

    pointBufPlus++;

    countBitPlus=countBitPlus+countBitW-8;

    bufPlus[pointBufPlus]=(UBYTE1)(w<<(8-countBitPlus));

   }

 }


void writeFileBufPlus(char *name)

 {if (countBitPlus==0)

   pointBufPlus--;

  ofstream output (name, ios::binary) ;

  if (!output)
   {cerr << "Can't open output file " << name << endl ;
    exit (1) ;
   }
  try
   {output.write(bufPlus, pointBufPlus+1);
    output.close();
   }

  catch (exception &ee)

   {cerr << ee.what () << endl ;
   }

 }


void initBufPlus()

 {rozmBufPlus=3+((24+9)*countColorPaletr+7)/8+(rozmBufPlus+7)/8;

  bufPlus=new UBYTE1[rozmBufPlus+1]; //      
  bufPlus[0]=0;//minusGreen*2+applyPredict;
  memcpy(bufPlus+1,&countColorPaletr,2);
  UBYTE2 i;
  for (i = 0 ; i < countColorPaletr ; ++ i)
   {bufPlus[3+3*i]=minRColorPaletr[i];
    bufPlus[3+3*i+1]=minGColorPaletr[i];
    bufPlus[3+3*i+2]=minBColorPaletr[i];
   }
  pointBufPlus=3+countColorPaletr*3;
  countBitPlus=0;
  bufPlus[pointBufPlus]=0; //  ,    
  for (i = 0 ; i < countColorPaletr; i++)
   {writeBufPlus(countBitRColorPaletr[i], 3);
    writeBufPlus(countBitGColorPaletr[i], 3);
    writeBufPlus(countBitBColorPaletr[i], 3);
   }
 }


void doneBufPlus()

 {delete bufPlus;

  bufPlus=NULL;

 }  



